"文法入門"

"コメント"
1 + 1 "this is a comment"

"オブジェクトとメッセージ"
Transcript show: 'Hello World!'	"do it"

'Squeak is cool' reverse	"print it"

"受け取り手がメッセージを受けつけられない場合"
Transcript reverse

"グローバルオブジェクト"

"true, false, nil"
true not.	"print it"
false not.	"print it"

myVar1 _ 1.

myVar2.

myVar1 _ nil.

"Transcript"
Transcript clear.	"Transcriptの内容を消去"

"ActiveWorld"
ActiveWorld color: Color random.	"現在の世界の色を変更"

ActiveWorld height.	"画面の高さ"
ActiveWorld width.	"画面の幅"

"Smalltalk"
Smalltalk.

Smalltalk version.		"バージョンを返す(print it)"
Smalltalk copyright.	"コピーライトを返す(print it)"
Smalltalk aboutThisSystem.	"システム情報のダイアログを開く(do it)"
Smalltalk snapshot: false andQuit: true.	"セーブしないで終了(do it)"

"リテラルオブジェクト"

"数字"
5. 

5 factorial.	"print it"

100 factorial.

2r1010.	"2進数の1010"
8r10000."8進数の10000"
16rFFFF.	"16進数のFFFF"

1.2.
3.1415e4.	"3.1415掛ける10の4乗"

3/2.

(3/2) asFloat.

"文字"
$a.
$A.
$1.
$$.

$a asciiValue.

"文字列"
'Hello World'.
'Happy Squeaking!'.

'For God''s sake'.

'This is a pen' first.	"print it"

'Hello World' asUppercase.		"文字列を全て大文字に"
'Hello World' asLowercase.		"文字列を全て大文字に"
'Hello World' reverse.		"文字列を逆さに"

"シンボル"
#abc == #abc. 	"print it"
#abc == #abc copy.	"print it"

'abc' == 'abc' copy.	"print it"

#'Hello World'
#'# is used in symbol!'

"配列"
#(1 2 3 4 5).	"inspect it"
#('orange' 'apple' 'banana' 'kiwi fruit').	"inspect it"

#(1 2 3 4 5) size.	"配列の要素数を聞く(print it)"
#('orange' 'apple' 'banana' 'kiwi fruit') reverse.	"配列を反対にする(print it)"

#(1 'two' #'three' $4).

#(1 2 #(1 2 3)).

#('orange' 'banana' 'grapefruits') at: 3.	"配列の3番目の要素を取り出す"

"動的配列"
{#(1 2 3) size. 'hello world' reverse. ActiveWorld width}.

#(#(1 2 3) size)	"print it"

"ブロック"
[Smalltalk beep].	"ビープ音を鳴らすためのブロックを作る"

myBlock _ [Smalltalk beep].	"ブロックをつくって変数に代入"
myBlock value.	"ここではじめて遅延実行(音が鳴る)"

[#(1 2 3) size. ActiveWorld width] value.	"print it"

"クラスから作られるオブジェクト"
joe _ Morph new.
joe openInWorld.

star _ StarMorph new.
star openInWorld.

Date today.	"今日の日付オブジェクトを生成(inspect it)"
Color random.	"ランダムな色を生成(inspect it)"

"変数への代入"
myName _ 'Masashi UMEZAWA'	"myNameに文字列オブジェクトをバインド"

myName size.	"文字列オブジェクトのサイズを聞く"

myName reverse.
myName asLowercase.

myName _ [ActiveWorld width].
myName _ #('orange' 'apple')

fruits _ #('apple' 'orange' 'banana').
favorites _ fruits.

fruits size.
favorites size.

fruits last.
favorites last.

a _ 1 negated	"1の符号反転をaにバインド"


"グローバル変数"
MyName _ 'Masashi Umezawa'.	"do it"

"一時変数"
| tmpName |
tmpName _ 'Masashi Umezawa'.
Transcript show: tmpName.

"メッセージの種類"

"単項メッセージ"
'Hello! Squeak' size. 		"文字列に大きさを聞く"
3 asString		"数字に自分を表す文字列を聞く"

"2項メッセージ"
3+1.
'Cool', 'Squeak'.

5 // 3. "商"
5 \\ 3. "余り"
5 >= 2.	 "以上か"
3 <= 2. "以下か"
'abc' = 'abc'.	"オブジェクトの値が同じか"
#abc == #abc.	"オブジェクトが同一か"5
1 ~= 2. "オブジェクトの値が異なるか"
1 ~~ 2. "オブジェクトが同一でないか"

"キーワードメッセージ"
Transcript show: 'ABC'.
#($a $b $c) at: 2.

'HelloSqueak' copyFrom: 2 to: 5.

'HelloSqueak' copyReplaceFrom: 2 to: 5 with: 'appy'.

"基本的な優先順位"
'Hello! Squeak' last asciiValue negated.

helloSqueak _ 'Hello! Squeak'.
lastCharacter _ helloSqueak last.
ascValue _ lastCharacter asciiValue.
ascValue negated.

3 + 5 * 4	"print it"

"メッセージの種類による優先順位"
'HelloSmalltalk' at: 1 negated + 7.

minus _ 1 negated.
index _ minus + 7.
'HelloSmalltalk' at: index.

"()の使用"
3 + 5 * 4.
3 + ( 5 * 4 ).

Transcript show: ('HelloSqueak' copyFrom: 6 to: 11).

"カスケード"
Transcript show: 'Hello'.
Transcript show: 'Good-bye'.

Transcript show: 'Hello';
		show: 'Good-bye'.

Transcript cr; 
		show: 'Hello';
		tab;
		show: 'Good-bye'.

"結果のリターン"
result _ 3 + 4.
^result.	"resultを返す"

^3 + 4.

"優先順位のくみあわせ"
Transcript show: (result _ (#('orange' 'banana' 'grapefruits') last copyFrom: 1 to: 2 + 3) asUppercase).
^result.

"制御構造"

"分岐"
"ifTrue: と ifFalse:"
1 < 3 ifTrue: [Transcript cr; show: 'もちろんtrue'].
ActiveWorld height >= ActiveWorld width ifFalse: [Transcript cr; show: '横長'].

(PopUpMenu confirm: 'Are you happy?')
	ifTrue:[Transcript cr; show: 'Yes. I am happy!']
	ifFalse:[Transcript cr; show: 'No...'].

PopUpMenu confirm: 'Are you happy?'

"and: と or:"
(3 > 1 and: [5 > 2]) ifTrue: [Transcript cr; show: 'Of course, true'].
(3 > 1 and: [1 > 2]) ifFalse: [Transcript cr; show: 'A is true, but B is false. So, false'].

(3 < 1 and: [PopUpMenu confirm: 'Are you happy?']) 
	ifTrue: [Transcript cr; show: 'Yes. I am happy!']

(3 < 1 & (PopUpMenu confirm: 'Are you happy?') )
	ifTrue: [Transcript cr; show: 'Yes. I am happy!']

"繰り返し"
"whileTrue:とwhileFalse:"
[PopUpMenu confirm: 'Are you happy?']
	whileFalse: [Transcript cr; show: 'Again?'].
Transcript cr; show: 'How happy you are!'.

(PopUpMenu confirm: 'Are you happy?')
	whileFalse: [Transcript cr; show: 'Again?'].

"to:do:"
array _ #('one' 'two' 'three').
1 to: 3 do: [:index | Transcript cr; show: (array at: index)].

array _ #('one' 'two' 'three' 'four' 'five' 'six').
2 to: 6 by: 2 do: [:index | Transcript cr; show: (array at: index)].

array _ #('one' 'two' 'three' 'four' 'five' 'six').
6 to: 1 by: -1 do:[:index | Transcript cr; show: (array at: index)].

array _ #('one' 'two' 'three').
array do: [:element | Transcript cr; show: element]

"timesRepeat:"
Transcript cr; show: 'slot --> '.
3 timesRepeat: [Transcript show: #(1 2 3 4 5 6 7) atRandom].	"do it"

'Happy Squeaking!!' atRandom.	"'Happy Squeaking!!'からランダムに一文字取り出す"

"repeat"
Transcript cr; show: 'dice  --> '.
count _ 0.
[first _ #(1 2 3 4 5 6) atRandom. "最初のさいころの目"
second _ #(1 1 2 2 3 4 5 6) atRandom. "2番目のさいころの目(1と2が出やすい)"
count _ count + 1.
first = second 
	ifTrue: [Transcript show: {first. second}. ^count. "ぞろ目を表示して抜ける"]
	ifFalse: [Transcript show: ' no! '.]
] repeat.

