"Collection"

"コレクションクラス群"

"Bag"
myBag _ Bag new.	"myBagという入れ物を用意"
myBag add: 'Happy Squeaking!'; add: Date today; add: #(1 2 3). 
       "何でもadd:で格納できる"
myBag add: Date today; add: 'Happy Squeaking!'; add: Date today. 
       "以前に入れたのと同じ要素を入れてみる"
myBag inspect.

"includes:"
myBag _ Bag new.
myBag add: 'Happy Squeaking!'; add: Date today; add: #(1 2 3). 
Transcript cr; show: (myBag includes: 'Happy Squeaking!').

"add:とremove:"
myBag _ Bag new.
myBag add: 'Happy Squeaking!'; add: Date today; add: #(1 2 3). 
myBag remove: 'Happy Squeaking!'. 
Transcript cr; show: (myBag includes: 'Happy Squeaking!').

"remove:ifAbsent:"
myBag _ Bag new.
myBag add: 'orange'.
myBag add: 'banana'.
myBag remove: 'peach' ifAbsent: [ Transcript cr; show: 'No peach here!'].

"occurrencesOf:"
myBag _ Bag new.
myBag add: 'Happy Squeaking!'; add: Date today; add: #(1 2 3). 
myBag add: Date today; add: 'Happy Squeaking!'; add: Date today. 
Transcript cr; show: (myBag occurrencesOf: 'Happy Squeaking!').
Transcript cr; show: (myBag occurrencesOf: Date today).

"addAll:とremoveAll:"
myBag _ Bag new.
myBag addAll: #('orange' 'apple').
myBag addAll: #('grape' 'peach'). 
Transcript cr; show: myBag .
myBag removeAll: #('apple' 'grape').
Transcript cr; show: myBag.

"Set"
mySet _ Set new.	"入れ物を用意｡今度はSet｡"
mySet add: 'Happy Squeaking!'; add: Date today; add: #(1 2 3). 
mySet add: Date today; add: 'Happy Squeaking!'; add: Date today. 
mySet inspect.

"asSet"
myBag _ Bag new.
myBag add: 'Happy Squeaking!'; add: Date today; add: #(1 2 3). 
myBag add: Date today; add: 'Happy Squeaking!'; add: Date today. 
mySet _ myBag asSet.	"Setに変換"
myBag inspect.
mySet inspect.

"Array"
myArray _ #('orange' 'apple' 'banana').
(myArray at: 2 ) inspect.	"2番目の要素をインスペクト"
myArray at: 1 put: 'peach'.	"1番目の要素を'peach'に変える"
myArray inspect.	"全体をインスペクト"

"new:"
myArray _ Array new: 3.
myArray at: 1 put: 'grape'.
myArray at: 2 put: 'melon'.
myArray inspect.	"全体をインスペクト。3番目はnil"

"with:with:"
myArray _ Array with: 'grape' with: 'melon'.
myArray inspect.

"OrderedCollection"
myOrderedCollection _ OrderedCollection new.
myOrderedCollection add: 'orange';
	add: 'apple';
	add: 'banana';
	add: 'apple'.
myOrderedCollection inspect.

"addFirst:"
myOrderedCollection _ OrderedCollection new.
myOrderedCollection add: 'orange';
	addFirst: 'apple';
	addFirst: 'banana';
	addFirst: 'apple'.
myOrderedCollection inspect.

"remove:"
myOrderedCollection _ OrderedCollection new.
myOrderedCollection add: 'orange';
	addFirst: 'apple'.
myOrderedCollection remove: 'orange'.
myOrderedCollection inspect.

"removeFirstとremoveLast"
myOrderedCollection _ OrderedCollection new.
myOrderedCollection add: Date today;
	add: 'I am in the middle';
	add: Time now.
myOrderedCollection removeFirst.
myOrderedCollection removeLast.
myOrderedCollection inspect.

"SortedCollection"
mySortedCollection _ SortedCollection new.
mySortedCollection add: 2.
mySortedCollection add: 3.
mySortedCollection add: 1.
mySortedCollection inspect.

mySortedCollection _ SortedCollection new.
mySortedCollection add: 'orange'.
mySortedCollection add: 'apple'.
mySortedCollection add: 'banana'.
mySortedCollection inspect.

mySortedCollection _ SortedCollection new.
mySortedCollection add: 'orange'.
mySortedCollection add: 1.
mySortedCollection add: 'banana'.
mySortedCollection inspect.

"sortBlock:"
mySortedCollection _ SortedCollection sortBlock: [:a :b | a > b].
mySortedCollection add: 2.
mySortedCollection add: 3.
mySortedCollection add: 1.
mySortedCollection inspect.

"複雑なsortBlock:"
mySortedCollection _ SortedCollection sortBlock: [:a :b | a asString <= b asString].
mySortedCollection add: 'orange'.
mySortedCollection add: 3.
mySortedCollection add: 'banana'.
mySortedCollection add: 'peach'.
mySortedCollection add: 1.
mySortedCollection inspect.

"Dictionary"
myDictionary _ Dictionary new.
myDictionary at: 'apple' put: '赤い'.
myDictionary at: 'banana' put: '黄色い'.
myDictionary at: 'durian' put: 'トゲトゲ'.
myDictionary inspect.

"at:とat:put:"
myDictionary _ Dictionary new.
myDictionary at: 'durian' put: '嫌い'.
myDictionary at: 'durian' put: '大好き'.
Transcript cr; show: (myDictionary at: 'durian' ).	"'大好き'と表示"

"at:ifAbsent:"
myDictionary _ Dictionary new.
myDictionary at: 1 put: 'one'.
myDictionary at: '1' put: 'ichi'.
Transcript cr; show: (myDictionary at: 1).	"'one'と表示される"
Transcript cr; show: (myDictionary at: '1').	"'ichi'と表示される"
Transcript cr; show: (myDictionary at: 'one' ifAbsent:['No such element!']).
	"'one'キーがないので'No such element!'と表示される"

"at:ifAbsentPut:"
myDictionary _ Dictionary new.
myDictionary at: 'today' ifAbsentPut: [Date today].
Transcript cr; show: (myDictionary at: 'today').

"keyとvalues"
myDictionary _ Dictionary new.
myDictionary at: 'apple' put: '赤い'.
myDictionary at: 'banana' put: '黄色い'.
myDictionary at: 'durian' put: 'トゲトゲ'.
Transcript cr; show: (myDictionary keys).
Transcript cr; show: (myDictionary values).

"IdentityDictionary"
myIdentityDictionary _ IdentityDictionary new.
myIdentityDictionary at: #apple put: '赤い'.
myIdentityDictionary at: #banana put: '黄色い'.
myIdentityDictionary at: #durian put: 'トゲトゲ'.
Transcript cr; show: (myIdentityDictionary at: #banana).	"'黄色い'と表示"
Transcript cr; show: (myIdentityDictionary at: 'banana').	"'エラー"

"Dictionaryとの比較"
myDictionary _ Dictionary new.
myDictionary at: #apple put: '赤い'.
myDictionary at: #banana put: '黄色い'.
myDictionary at: #durian put: 'トゲトゲ'.
Transcript cr; show: (myDictionary at: #banana).	"'黄色い'と表示"
Transcript cr; show: (myDictionary at: 'banana').	"'黄色い'と表示"

"コレクションの変換"
fruitsArray _ #('orange' 'banana' 'apple').
fruitsOrderedCollection _ fruitsArray asOrderedCollection.
fruitsSet _ fruitsArray asSet.
fruitsSortedCollection _ fruitsOrderedCollection asSortedCollection.

fruitsArray _ #('orange' 'banana' 'apple').
fruitsOrderedCollection _ fruitsArray asOrderedCollection.
fruitsOrderedCollection at: 1 put: 'grape'.

Transcript cr; show: fruitsArray.
Transcript cr; show: fruitsOrderedCollection.

"Dictionaryの変換"
myDictionary _ Dictionary new.
myDictionary at: 'apple' put: '赤い'.
myDictionary at: 'banana' put: '黄色い'.
myDictionary at: 'durian' put: 'トゲトゲ'.
myDictionary asSortedCollection inspect.
myDictionary keys asSortedCollection inspect.

"yourself"
myOrderedCollection _ OrderedCollection new .
(myOrderedCollection add: #one) remove: #one.	"addした後ですぐにremove"

"yourselfなしの場合"
myDictionary _ (Dictionary new)
     at: 'apple' put: '赤い';
     at: 'banana' put: '黄色い';
     at: 'durian' put: 'トゲトゲ'.
myDictionary inspect.

"yourselfありの場合"
myDictionary _ (Dictionary new)
     at: 'apple' put: '赤い';
     at: 'banana' put: '黄色い';
     at: 'durian' put: 'トゲトゲ';
       yourself.
myDictionary inspect.

"以下イテレートプロトコル"

"do:"
myArray _ #(#one #two #three).
myArray do: [:each | Transcript cr; show: each ].

Smalltalk keys do: [:each | Transcript cr; show: each ].

"select:"
#(1 2 3 4 5 6) select: [:each | (each \\ 3) = 1].

(Smalltalk keys select: [:each | each beginsWith: 'A']) 
	do: [:each | Transcript cr; show: each].

"reject:"
#(1 2 3 4 5 6) reject: [:each | (each \\ 3) = 1].

#(1 2 3 4 5 6) select: [:each | ((each \\ 3) = 1) not].

"detect:"
#(1 2 3 4 5) detect: [:each | each even].

#(1 2 3 4 5) detect: [:each | each isDivisibleBy: 7].

found _ #(1 2 3 4 5) detect: [:each | each isDivisibleBy: 7]
                        ifNone: [Transcript cr; show: 'Not found'. nil ].
^found.

found _ #(1 2 3 4 5) detect: [:each | each isDivisibleBy: 7] ifNone: [].
found isNil ifTrue: [Transcript cr; show: 'Not found'].
^found.

"collect:"
newCollection _ #(1 2 3 4 5) collect: [:each | each asString].
^newCollection.

newCollection _ OrderedCollection new.
#(1 2 3 4 5) do: [:each | newCollection add: (each asString)].
^newCollection asArray.

"inject:into:"
#(1 2 3 4 5) inject: 0 into: [:subTotal :each | subTotal + each].

total _ 0.
#(1 2 3 4 5) do: [:each | total _ total + each].
^total.

Smalltalk keys inject: 0 into: [:longest :each | longest max: each size].

longest _ 0.
Smalltalk keys do: [:each | longest _ longest max: each size].
^longest

#('smalltalk' 'is' 'a' 'cool' 'language') 
    inject: String new
    into: [:sentence :nextWord | sentence, nextWord capitalized].

(Smalltalk allClasses 
       inject: Set new 
       into: [:allSelectors :eachClass |
		allSelectors addAll: eachClass selectors;
		    addAll: eachClass class selectors;
		    yourself]) size.

"keysDo:"
Smalltalk keysDo: [:each | Transcript cr; show: each ].

"valuesDo:とassociationsDo:"
weekDayDictionary _ Dictionary new.
weekDayDictionary at: '月' put: 'Monday'.
weekDayDictionary at: '火' put: 'Tuesday'.
weekDayDictionary at: '水' put: 'Wednesday'.
weekDayDictionary at: '木' put: 'Thursday'.
weekDayDictionary at: '金' put: 'Friday'.
weekDayDictionary valuesDo: [:each | Transcript cr; show: each ].	

weekDayDictionary 
    associationsDo: [:association | 
        Transcript cr; show: association key. 
        Transcript space; show: association value].

weekDayDictionary 
        associationsDo: [:association | 
            Transcript cr; show: association].	

