"Morph"

"サブモーフ"
morph _ RectangleMorph new openInWorld.	"四角モーフを生成してオープン"
morph bounds: (morph bounds expandBy: 20)."見やすさのため大きめに"
morph addMorph: EllipseMorph new.	"四角モーフに楕円モーフを追加"

"サブモーフの順番"
morph _ RectangleMorph new openInWorld.
morph bounds: (morph bounds expandBy: 20).
morph addMorph: (EllipseMorph new center: morph center).	"楕円モーフ追加"
morph addMorph: (CurveMorph new center: morph center). "カーブモーフ追加"
morph addMorph: (StarMorph new center: morph center). "星形モーフ追加"

morph _ RectangleMorph new openInWorld.
morph bounds: (morph bounds expandBy: 20).
morph addMorph: (CurveMorph new center: morph center). "カーブモーフ追加"
morph addMorph: (StarMorph new center: morph center). "星形モーフ追加"
morph addMorph: (EllipseMorph new center: morph center). "楕円モーフ追加"

morph firstSubmorph.

morph _ RectangleMorph new openInWorld.
morph bounds: (morph bounds expandBy: 20).
morph addMorphFront: (StarMorph new center: morph center).
morph addMorph: (CurveMorph new center: morph center).
morph addMorphBack: (EllipseMorph new center: morph center).

"オーナーの確認"
morph _ RectangleMorph new openInWorld.
morph bounds: (morph bounds expandBy: 20).
submorph _ EllipseMorph new center: morph center.
morph addMorph: submorph.	"四角モーフに楕円モーフを追加"
submorph inspect.	"サブモーフとなっている楕円モーフをインスペクト"

"ActiveWorld"
ActiveWorld color: Color random.	"do it"

ActiveWorld explore.	"inspectのかわりにexploreを送る"

"オーナーの差し替え"
morph _ RectangleMorph new openInWorld.	"四角モーフをオープン"
morph bounds: (morph bounds expandBy: 20).
submorph _ EllipseMorph new center: morph center.	"楕円モーフを生成"
morph addMorph: submorph.	"四角モーフに楕円モーフをサブモーフとして追加"

starMorph _ StarMorph new openInWorld.	"星形モーフを生成"
starMorph center: ActiveWorld center.	"画面の中央に移動"
starMorph addMorph: submorph.	"星形モーフに楕円モーフをサブモーフとして追加"

"サブモーフの検索"
morph _ RectangleMorph new openInWorld.	"四角モーフをオープン"
morph bounds: (morph bounds expandBy: 20).
morph addMorph: EllipseMorph new."楕円モーフを追加"
morph addMorph: StarMorph new. "星形モーフ追加"

submorph _ morph findA: StarMorph.
submorph color: Color red.

submorph _ morph findA: EllipseMorph.
submorph color: Color red.

submorph _ morph findA: RectangleMorph.
submorph isNil ifTrue: [PopUpMenu inform: 'そんなサブモーフは見つかりません'].

"複数候補がある場合"
morph _ RectangleMorph new openInWorld.	
morph bounds: (morph bounds expandBy: 20). 
morph addMorph: 
	(StarMorph new color: Color blue).	"青の星形モーフを追加"
morph addMorph: 
	(StarMorph new color: Color green; center: morph center).	"緑の星形モーフを真ん中に追加"

submorph _ morph findA: StarMorph.
submorph color: Color yellow.

"オーナーモーフの検索"
morph _ RectangleMorph new openInWorld.	
morph bounds: (morph bounds expandBy: 20). 
elli _ EllipseMorph new color: Color blue.
morph addMorph: elli.
star _ StarMorph new.
elli addMorph: (star center: elli center).

(elli ownerThatIsA: RectangleMorph) color: Color red.

(star ownerThatIsA: RectangleMorph) color: Color green.

"ActiveHand"
ActiveHand inspect.

EllipseMorph new openInWorld.

Preferences disable: #fastDragWindowForMorphic.

Preferences enable: #fastDragWindowForMorphic.

"フレックスシェル"
morph _ RectangleMorph new openInWorld.

morph inspect.

"レイアウト"
morph _ RectangleMorph new openInWorld.
morph bounds: (morph bounds extendBy: 100). "左上をそろえて100ドットずつ拡大"

"レイアウトポリシーなしの場合"
redSubmorph _ RectangleMorph new.
redSubmorph color: Color red.
morph addMorph: redSubmorph.	"サブモーフを追加"
redSubmorph position: morph topRight.	"オーナーの右上に位置を合わせる"

blueSubmorph _ RectangleMorph new.
blueSubmorph color: Color blue.
morph addMorph: blueSubmorph.	"サブモーフを追加"
blueSubmorph center: ActiveWorld center.	"ワールドの中心に位置を合わせる"

"ポリシーの適用"
morph changeTableLayout.	"TableLayoutをオーナーに適用"

"プロポーショナル･レイアウト"
morph _ Morph new openInWorld.
morph extent: 100@80.
morph layoutPolicy: ProportionalLayout new.	"プロポーショナル･レイアウトにする"

morph changeProportionalLayout.	"プロポーショナル･レイアウトにする"

morph layoutPolicy.	"inspect it"

"フレームの使用"
frame _ LayoutFrame fractions: (0.5@0.5 corner: 1@1).	"右下の4分の1区画のフレームを作る"
submorph _ Morph new color: Color yellow.	"黄色いサブモーフを作る"
morph addMorph: submorph fullFrame: frame.	"フレームを指定してサブモーフを追加"

frame _ LayoutFrame fractions: (0.1@0.1 corner: 0.9@0.9).
morph addMorph: submorph fullFrame: frame.

"オフセット"
frame _ LayoutFrame fractions: (0@0 corner: 1@1) offsets: (10@10 corner: -10@-10).	"全体の大きさから10ドットずつ内側"
morph addMorph: submorph fullFrame: frame.

"テーブル･レイアウト"
morph _ Morph new.
morph extent: 200@200.
morph changeTableLayout.	"テーブル･レイアウトにする"

morph addMorph: (Morph new color: Color yellow).
morph addMorph: (Morph new color: Color green).
morph addMorph: (Morph new color: Color red).
morph openInWorld.

morph addMorph: (Morph new color: Color random).

"listDirection:"
morph listDirection: #leftToRight.	"左から右へ"

morph listDirection:# topToBottom.	"デフォルトに戻す"

"layoutInset:"
morph layoutInset: 3.	"テーブル･レイアウトの領域を3ドット内側にする"

morph layoutInset: 10@3.

"cellInset:"
morph cellInset: 5.	"サブモーフ間の間隔を5ドット開ける"

"wrapCentering:"
morph wrapCentering: #center.	"do it"

morph listDirection:#leftToRight.	"do it"
morph wrapCentering: #bottomRight.	"do it"

"listCentering:"
morph _ Morph new.
morph extent: 200@200.
morph changeTableLayout.	
morph addMorph: (Morph new color: Color yellow).
morph addMorph: (Morph new color: Color green).
morph addMorph: (Morph new color: Color red).
morph openInWorld.

morph listCentering: #center.

morph listCentering: #bottomRight.

morph listCentering: #justified.

morph listCentering: #topToBottom.

"hResizing:とvResizing:"
morph hResizing: #shrinkWrap.	"横方向をサブモーフに合わせて縮むように指定"

morph vResizing: #shrinkWrap.	"縦方向をサブモーフに合わせて縮むように指定"

morph _ Morph new.
morph extent: 200@200.
morph changeTableLayout.
morph addMorph: (yellow _ Morph new color: Color yellow).
morph addMorph: (green _ Morph new color: Color green).
morph addMorph: (red _ Morph new color: Color red).
morph openInWorld.

red hResizing: #spaceFill.	"横方向に間を埋めるリサイズ指定"

yellow vResizing: #spaceFill.		"縦方向に間を埋めるリサイズ指定"

red hResizing: #rigid.	"横方向にはリサイズしない指定"


"拡張属性、プロパティ関連"
morph _ Morph new.
morph layoutPolicy: TableLayout new.	"テーブル･レイアウトに設定"
morph listDirection: #bottomToTop. 	"サブモーフの並び方向を縦に"
morph vResizing:#spaceFill.	"縦のリサイズを#spaceFillに"
Transcript cr; show: morph layoutPolicy.	"レイアウトポリシーを表示"
Transcript cr; show: morph listDirection.	"サブモーフの並び方向を表示"
Transcript cr; show: morph vResizing.		"縦のリサイズポリシーを表示"

morph inspect.

"locked, visible, externalName"
morph _ Morph new.
morph center: ActiveWorld center. "位置をActiveWorldの中心に合わせる"
morph openInWorld.	
morph lock.

morph extension inspect.
morph unlock.

morph hide.
morph show.

morph name: 'ume'.	"do it"

morph knownName.	"print it"

"otherProperties"
morph _ Morph new openInWorld.
morph setProperty: #creationTime toValue: Time now.	"モーフの作成時間(#creationTime)というプロパティをセット"
Transcript cr; show: (morph valueOfProperty: #creationTime).	"#creationTimeの値を表示"
Transcript cr; show: (morph hasProperty: #creationTime).	"#creationTimeプロパティがあるか"

morph extension inspect.

morph removeProperty: #creationTime.	"#creationTimeプロパティを削除"	

