'From SqueakNihongo6.1 of 15 April 2004 [latest update: #1] on 7 June 2004 at 5:57:40 pm'!
"Change Set:		Mole Attack
Date:			5 June 2004
Author:			Masashi Umezawa

モグラたたきゲーム。2匹のモグラが出てきます。
MoleHoleMorph new openInWorld.
MoleAttackBoardMorph new openInWorld.

"!]lang[(73 10 1 12 72)0,5,0,5,0!

Morph subclass: #MoleAttackBoardMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mole Attack'!
Morph subclass: #MoleHoleMorph
	instanceVariableNames: 'isGameOver score miss stepTime '
	classVariableNames: 'MoleForms '
	poolDictionaries: ''
	category: 'Mole Attack'!

!MoleAttackBoardMorph methodsFor: 'initialization' stamp: 'mu 6/5/2004 18:38'!
initLayout
	self changeTableLayout.
	self listDirection: #leftToRight.
	self hResizing: #shrinkWrap.
	self vResizing: #shrinkWrap.
	2 timesRepeat: [self addMorph: MoleHoleMorph new].
! !

!MoleAttackBoardMorph methodsFor: 'initialization' stamp: 'mu 6/5/2004 18:39'!
initialize
	"モーフの初期化"
	super initialize.
	self initLayout
!]lang[(13 7 38)0,5,0! !

!MoleAttackBoardMorph methodsFor: 'private' stamp: 'mu 6/5/2004 18:45'!
failed
	self miss > 10
		ifTrue: [PopUpMenu inform: self score asString.
			self submorphs
				do: [:each | each isGameOver: true]]
! !

!MoleAttackBoardMorph methodsFor: 'accessing' stamp: 'mu 6/5/2004 18:43'!
miss
	^ (self submorphs
		collect: [:each | each miss]) sum
! !

!MoleAttackBoardMorph methodsFor: 'accessing' stamp: 'mu 6/5/2004 18:43'!
score
	^ (self submorphs
		collect: [:each | each score]) sum
! !


!MoleHoleMorph methodsFor: 'initialization' stamp: 'mu 6/3/2004 17:48'!
initLayout
	| frame |
	self extent: 74 @ 74.	"大きさの設定"
	self changeProportionalLayout. "プロポーショナル・レイアウトにする"
	frame _ LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 1)
				offsets: (2 @ 2 corner: -2 @ -2).
	
	"サブモーフの追加"
	MoleForms
		keysAndValuesDo: [:key :form | 
			| morph | 
			morph _ SketchMorph withForm: form.
			morph name: key.
			self addMorph: morph fullFrame: frame]!]lang[(46 6 35 17 102 8 161)0,5,0,5,0,5,0! !

!MoleHoleMorph methodsFor: 'initialization' stamp: 'mu 6/3/2004 17:45'!
initialize
	super initialize.
	isGameOver _ false.
	score _ 0.
	miss _ 0.
	stepTime _ 500.
	self initLayout. "レイアウトの初期化"
	!]lang[(110 9 3)0,5,0! !

!MoleHoleMorph methodsFor: 'initialization' stamp: 'mu 6/3/2004 17:50'!
openInWorld
	MoleForms isEmpty
		ifTrue: [^PopUpMenu inform: '画像を取り込んでください'].
	super openInWorld
!]lang[(62 12 23)0,5,0! !

!MoleHoleMorph methodsFor: 'stepping' stamp: 'mu 6/3/2004 17:48'!
step
	| sketch |
	self isGameOver ifTrue: [^self]. "ゲームオーバーであれば何もしないで抜ける"
	sketch _ self submorphs atRandom.
	self addMorph: sketch.
	self color: Color blue.	"通常は青色にしておく"!]lang[(52 20 87 10 1)0,5,0,5,0! !

!MoleHoleMorph methodsFor: 'stepping' stamp: 'mu 3/16/2004 23:07'!
stepTime
	^stepTime! !

!MoleHoleMorph methodsFor: 'stepping' stamp: 'mu 4/1/2004 19:20'!
stepTime: milliSeconds
	stepTime _ milliSeconds max: 0.
	! !

!MoleHoleMorph methodsFor: 'accessing' stamp: 'mu 4/1/2004 19:29'!
isGameOver
	^isGameOver! !

!MoleHoleMorph methodsFor: 'accessing' stamp: 'mu 4/1/2004 19:29'!
isGameOver: aBoolean
	isGameOver _ aBoolean! !

!MoleHoleMorph methodsFor: 'accessing' stamp: 'mu 4/1/2004 19:29'!
miss
	^miss! !

!MoleHoleMorph methodsFor: 'accessing' stamp: 'mu 4/1/2004 19:29'!
miss: anInteger
	miss _ anInteger! !

!MoleHoleMorph methodsFor: 'accessing' stamp: 'mu 4/1/2004 19:27'!
score
	^score! !

!MoleHoleMorph methodsFor: 'accessing' stamp: 'mu 4/1/2004 19:28'!
score: anInteger
	score _ anInteger! !

!MoleHoleMorph methodsFor: 'event handling' stamp: 'mu 4/1/2004 19:29'!
handlesMouseDown: evt
	^ self isGameOver not.! !

!MoleHoleMorph methodsFor: 'event handling' stamp: 'mu 4/2/2004 23:08'!
mouseDown: evt 
	self firstSubmorph knownName = 'Mole'
		ifTrue: [self hit]
		ifFalse: [self failed].
	! !

!MoleHoleMorph methodsFor: 'private' stamp: 'mu 6/5/2004 18:49'!
failed
	self color: Color yellow.	"色を黄色に"
	self playSound: 'warble'. 	"はずれたときの音を鳴らす"
	self score: self score - 5.	"スコアを5点減点"
	self miss: self miss + 1.	"ミスの回数を追加"

	(self ownerThatIsA: MoleAttackBoardMorph)
		ifNotNilDo: [:board | ^board failed].
			"オーナーがMoleAttackBoardMorphのときにはオーナーにfailedを送って抜ける"

	"5回よりもミスが多ければゲームオーバー"
	self miss > 5
		ifTrue: [self isGameOver: true.
			PopUpMenu inform: self score asString]
!]lang[(35 5 31 12 32 4 1 3 30 8 90 5 20 10 6 7 6 18 93)0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,0! !

!MoleHoleMorph methodsFor: 'private' stamp: 'mu 6/3/2004 17:49'!
hit
	self color: Color red.		"色を赤に"
	self playSound: 'chirp'.	"当たったときの音を鳴らす"
	self stepTime: self stepTime - 50.	"間隔を50ミリ秒減らす"
	self score: self score + 10.	"スコアを10点追加"
!]lang[(30 4 29 12 39 3 2 6 33 4 2 3 2)0,5,0,5,0,5,0,5,0,5,0,5,0! !

!MoleHoleMorph methodsFor: 'private' stamp: 'mu 4/2/2004 23:37'!
playSound: soundName 
	(SampledSound soundNamed: soundName) play.
	! !


!MoleHoleMorph class methodsFor: 'class initialization' stamp: 'mu 4/2/2004 02:25'!
initialize
	"MoleHoleMorph initialize"
	MoleForms _ IdentityDictionary new.
	! !

!MoleHoleMorph class methodsFor: 'class initialization' stamp: 'mu 4/2/2004 02:07'!
registerAllForms
	"MoleHoleMorph registerAllForms"
	#(#Hole #HalfMole #Mole )
		do: [:each | self registerAt: each fromFileNamed: each , '.png']! !

!MoleHoleMorph class methodsFor: 'accessing' stamp: 'mu 4/2/2004 01:44'!
moleForms
	^MoleForms! !

!MoleHoleMorph class methodsFor: 'utilities' stamp: 'mu 4/3/2004 00:33'!
registerAt: aSymbol fromFileNamed: fineName
	"MoleHoleMorph registerAt: #Hole fromFileNamed: 'Hole.png'"

	| form |
	form _ ImageReadWriter formFromFileNamed: fineName.
	MoleForms at: aSymbol put: form! !

MoleHoleMorph initialize!
"Postscript: 画像を読みオープン"
"画像の読み込み"
MoleHoleMorph registerAllForms.

"MoleAttackBoardをオープンする"
MoleAttackBoardMorph new openInWorld.!]lang[(13 9 3 7 51 7 39)0,5,0,5,0,5,0!

