"Exception"

"例外処理"
[ 1/0 ] on: ZeroDivide do: [:ex | Transcript cr; show: '0では割れません'].

[ 1/1 ] on: ZeroDivide do: [:ex | Transcript cr; show: '0では割れません'].

1/0.	"do it"

"例外の発生"
ZeroDivide dividend: 1.

(ZeroDivide dividend: 1) signal.
(ZeroDivide dividend: 1) signal:'0で割りました!'.

"例外の捕捉"
[ 1/0 ] on: ZeroDivide do: [:ex | Transcript cr; show: '0では割れません'].

[ 1/nil ] on: ZeroDivide do: [:ex | Transcript cr; show: 'nilでは割れません'].

[ 1/0 "or 1/nil"] on: ZeroDivide, MessageNotUnderstood
        do: [:ex | Transcript cr; show: '0やnilでは割れません'].

[1/0 "or 1/nil" ] on: Error
        do: [:ex | Transcript cr; show: '0やnilでは割れません'].

"回復処理"
[ 1/0] on: ZeroDivide
        do: [:ex | ex inspect].	"do it"

"例外情報の取り出し"
[ 1/0] on: ZeroDivide
        do: [:ex | Transcript cr; show: ex dividend asString, 'を0では割れません'].

[ ZeroDivide new signal: 'エラー! 0では割れません'] on: ZeroDivide
        do: [:ex | Transcript cr; show: ex messageText.].	"do it"

[ 1/0 ] on: ZeroDivide
        do: [:ex | Transcript cr; show: ex description.].	"do it"

Error new signal: 'エラーが発生しました。'

[ 1/nil ] on: MessageNotUnderstood
        do: [:ex | Transcript cr; show: ex messageText.
                   Transcript cr; show: ex description.].	"do it"

"捕捉後の制御"

"return, return:"
returnValue _ [ 1/0 ] on: ZeroDivide do: [:ex | 
	Transcript cr; show: ex description.
	ex return.
	Transcript cr; show: 'ここは実行されません'.]. 
returnValue.	"print it"

returnValue _ [ 1/0 ] on: ZeroDivide do: [:ex | 
	Transcript cr; show: ex description.
	ex return: Time now.
	Transcript cr; show: 'ここは実行されません'.]. 
returnValue.	"print it"

"pass"
returnValue _ [ 1/0 ] on: ZeroDivide do: [:ex | 
	Transcript cr; show: ex description.
	ex pass.
	Transcript cr; show: 'ここは実行されません'.]. 
returnValue.	"print it"

[ [1/0] on: ZeroDivide do: [:ex | 
	Transcript cr; show: ex description , 'ちょっと回復'.
	ex pass.
	Transcript cr; show: 'ここは実行されません']  ]
	on: ZeroDivide
	do: [:ex | Transcript cr; show: ex description , 'もっと回復'].

[ [1/0 "or 1/nil"] on: ZeroDivide, MessageNotUnderstood do: [:ex |
	Transcript cr; show: ex description , 'ちょっと回復'.
	ex pass.
	Transcript cr; show: 'ここは実行されません'] ]
	on: Error
	do: [:ex | Transcript cr; show: ex description , 'もっと回復'].

"retry, retryUsing:"
divisor _ nil.
returnValue _ [1 / divisor] on: MessageNotUnderstood do: [:ex | 
	  divisor _ 1.
	  Transcript cr; show: '割る数がnilなので1にしました｡'.
	  ex retry].
returnValue.

divisor _ nil.
returnValue _ [1 / divisor]
	    on: MessageNotUnderstood
	    do: [:ex | 
		divisor _ 1.
		ex retryUsing: [Transcript cr; show: 'やり直します'. 2/divisor]].
returnValue.

"resume"
{ZeroDivide. MessageNotUnderstood. Error} 
       collect: [:each | each new isResumable]. "print it"

divisor _ 2. "or nil"
[result _ 1 / divisor. "例外が発生すると => ハンドラブロックへ"
Transcript cr; show: 'divisor is ', divisor asString. 
Transcript cr; show: 'result is ', result asString]
	on: MessageNotUnderstood
	do: [:ex | 
		divisor _ 1.
		Transcript cr; show: ' 割る数を1にしました｡'.
		ex resume. "例外発生のすぐ後から再開"].

[Error new signal: 'エラー!'.	"再開不可能なErrorをあえて発生"
Transcript cr; show: '再開?']
	on: Error
	do: [:ex | 
		ex resume. "再開を試みる"].

