"Meta"

"メタレベルのプロトコル"

"クラスを調べる"
OrderedCollection superclass.	"クラスに対してスーパークラスを聞く"

OrderedCollection allSuperclasses.	"ルートまでの全てのスーパークラスを聞く"

OrderedCollection subclasses.	"直下のサブクラス群を聞く"

OrderedCollection allSubclasses.	"全てのサブクラス群を聞く"

OrderedCollection printHierarchy.	"クラスの継承ツリーの文字列を得る"

OrderedCollection definition.	"クラスの定義情報の文字列を得る"

OrderedCollection comment. 	"クラスのコメントをテキストで得る"

OrderedCollection comment asString.

"メソッド"
OrderedCollection selectors.	"セレクタの集合を得る"

OrderedCollection allSelectors. "スーパークラス群を含めた全てのセレクタの集合を得る"

OrderedCollection sourceCodeAt: #add:.	"add:のソースコードを得る"

OrderedCollection compiledMethodAt: #add:.	"add:のコンパイルされたバイトコードを得る(inspect it)"

OrderedCollection methodDict.	"メソッド辞書を得る(inspect it)"

OrderedCollection class methodDict.	"inspect it"

"変数"
OrderedCollection instVarNames.	"インスタンス変数の名前リストを得る"

Date classVarNames.	"クラス変数の名前リストを得る"

OrderedCollection class instVarNames.

Account class instVarNames. "銀行口座クラスのクラスインスタンス変数名リストを取得"

"インスタンスを操る"

"respondsTo:"
ord _ OrderedCollection new.
ord respondsTo: #at:put:. "OrderedCollectionにat:put:メッセージが答えられるか聞く"

ord respondsTo: #keys "OrderedCollectionにkeysメッセージが答えられるか聞く"

"perform:"
ord _ OrderedCollection new.
ord size.

ord _ OrderedCollection new.
ord perform: #size.

ord _ OrderedCollection new.
selector _ #add:.		"セレクタを用意"
args _ #('Squeak').	"引数を用意"
ord perform: selector withArguments: args.
ord inspect.

"instVarAt:"
OrderedCollection instVarNames.	"print it"

ord _ OrderedCollection new.
ord add: 'a'; add:'b'; add:'c'.
ord instVarAt: 1.	"一番目に定義されたインスタンス変数の値を取り出す"

"instVarNamed:"
ord instVarNamed: 'firstIndex'.	"'firstIndex'という名前のインスタンス変数の値を取り出す(print it)"

"instVarAt:put:"
acc _ Account new.
acc deposit: 1000.
varNames _ acc class instVarNames. "クラスから変数のリストを得る"
index _ varNames indexOf: 'id'. "'id'変数が何番目に定義されているか"
acc instVarAt: index put: 123. "値の書き換え"
acc inspect.

"instVarNamed:put:"
acc _ Account new.
acc deposit: 1000.
acc instVarNamed: 'id' put: 234. "変数名(id)を利用した値の書き換え"
acc inspect.

"isMemberOf:"
3@4 isMemberOf: Point.	"print it"

Smalltalk isMemberOf: SystemDictionary.	"print it"

"isKindOf:"
elli _ EllipseMorph new.
elli isKindOf: Morph.	"print it"

elli _ EllipseMorph new.
rec _ RectangleMorph new.

elli isMemberOf: RectangleMorph.	"print it"
rec isMemberOf: RectangleMorph.	"print it"
rec isKindOf: RectangleMorph.	"print it"
rec isKindOf: Morph.	"print it"
elli isKindOf: Morph.	"print it"

"become:"
accA _ Account new.
accA id: 'Yamada'.
accA deposit: 10000.
accA inspect.	"accAはidが'Yamada'で残高は10000 "

accB _ Account new.
accB id: 'Suzuki'.
accB deposit: 2000.
accB inspect.	"accBはidが'Suzukiで残高は2000 "

accA become: accB.	"互いの実体の入れ替え(do it)"

"becomeForward:"
accA becomeForward: accB.	"accAをaccBに"

"doesNotUnderstand:"
"SilentObjectを定義しておいてください"
silentObject _ SilentObject new.
silentObject add: 'hello'.
silentObject openInWorld.
silentObject nextPutAll: 'this is okay?'.
silentObject inspect.

proxy _ LoggingProxy on: OrderedCollection new.	"OrderedCollectionのふりをするプロキシの作成"

proxy add: 'hello'.
proxy add: 'squeak'.
proxy collect: [:each | each asUppercase].
proxy reverse collect: [:each | each capitalized].
proxy asArray inspect.

"コンパイラを使う"

"scanTokens:"
Scanner new scanTokens: '#(this is) $a #symbol. 16rFFFF'.	

"parse:class:"
sourceString _ OrderedCollection sourceCodeAt: #do:.	"OrderedCollection >> do:のソースコードを取り出す"
Parser new parse: sourceString class: OrderedCollection. "パース"

"evaluate:"
Compiler evaluate: '3+4'.	"print it"

Compiler evaluate: '
| merged firstArray secondArray |
firstArray _ #(1 2 3).
secondArray _ #($a $b $c).
merged _ OrderedCollection new.
firstArray with: secondArray do: [:firstEach :secondEach | merged add: firstEach; add: secondEach].
^merged
'.

"メタクラス"
OrderedCollection class inspect.	"do it"

Browser newOnClass: OrderedCollection class.	"do it"

OrderedCollection methodDict inspect.		"do it"
OrderedCollection class methodDict inspect.	"do it"

Account printHierarchy.	"print it"
Account class printHierarchy.	"print it"

Account class allInstances.	"print it"

Account class.	"print it"
Metaclass class.	"print it"
Account class class.	"print it"
Metaclass class class.	"print it"

